<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Class: Lyrix::LyricParser</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <link rel="stylesheet" href="../.././rdoc-style.css" type="text/css" media="screen" />
  <script type="text/javascript">
  // <![CDATA[

  function popupCode( url ) {
    window.open(url, "Code", "resizable=yes,scrollbars=yes,toolbar=no,status=no,height=150,width=400")
  }

  function toggleCode( id ) {
    if ( document.getElementById )
      elem = document.getElementById( id );
    else if ( document.all )
      elem = eval( "document.all." + id );
    else
      return false;

    elemStyle = elem.style;
    
    if ( elemStyle.display != "block" ) {
      elemStyle.display = "block"
    } else {
      elemStyle.display = "none"
    }

    return true;
  }
  
  // Make codeblocks hidden by default
  document.writeln( "<style type=\"text/css\">div.method-source-code { display: none }</style>" )
  
  // ]]>
  </script>

</head>
<body>



    <div id="classHeader">
        <table class="header-table">
        <tr class="top-aligned-row">
          <td><strong>Class</strong></td>
          <td class="class-name-in-header">Lyrix::LyricParser</td>
        </tr>
        <tr class="top-aligned-row">
            <td><strong>In:</strong></td>
            <td>
                <a href="../../files/lib/lyric_parser_rb.html">
                lib/lyric_parser.rb
                </a>
        <br />
            </td>
        </tr>

        <tr class="top-aligned-row">
            <td><strong>Parent:</strong></td>
            <td>
                Object
            </td>
        </tr>
        </table>
    </div>
  <!-- banner header -->

  <div id="bodyContent">



  <div id="contextContent">



   </div>

    <div id="method-list">
      <h3 class="section-bar">Methods</h3>

      <div class="name-list">
      <a href="#M000061">lyrics=</a>&nbsp;&nbsp;
      <a href="#M000060">new</a>&nbsp;&nbsp;
      <a href="#M000062">parse</a>&nbsp;&nbsp;
      <a href="#M000063">parse!</a>&nbsp;&nbsp;
      <a href="#M000064">to_slides</a>&nbsp;&nbsp;
      </div>
    </div>

  </div>


    <!-- if includes -->

    <div id="section">


    <div id="constants-list">
      <h3 class="section-bar">Constants</h3>

      <div class="name-list">
        <table summary="Constants">
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">DEFAULT_OPTIONS</td>
          <td>=</td>
          <td class="context-item-value">{}</td>
        </tr>
        </table>
      </div>
    </div>



    <div id="attribute-list">
      <h3 class="section-bar">Attributes</h3>

      <div class="name-list">
        <table>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">lyrics</td>
          <td class="context-item-value">&nbsp;[R]&nbsp;</td>
          <td class="context-item-desc"></td>
        </tr>
        </table>
      </div>
    </div>
      


    <!-- if method_list -->
    <div id="methods">
      <h3 class="section-bar">Public Class methods</h3>

      <div id="method-M000060" class="method-detail">
        <a name="M000060"></a>

        <div class="method-heading">
          <a href="#M000060" class="method-signature">
          <span class="method-name">new</span><span class="method-args">(lyrics, options = {})</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000060-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000060-source">
<pre>
    <span class="ruby-comment cmt"># File lib/lyric_parser.rb, line 7</span>
 7:     <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">initialize</span>(<span class="ruby-identifier">lyrics</span>, <span class="ruby-identifier">options</span> = {})
 8:       <span class="ruby-ivar">@options</span> = <span class="ruby-constant">DEFAULT_OPTIONS</span>.<span class="ruby-identifier">merge</span>(<span class="ruby-identifier">options</span>)
 9:       <span class="ruby-ivar">@lyrics</span> = <span class="ruby-identifier">lyrics</span>
10:     <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <h3 class="section-bar">Public Instance methods</h3>

      <div id="method-M000061" class="method-detail">
        <a name="M000061"></a>

        <div class="method-heading">
          <a href="#M000061" class="method-signature">
          <span class="method-name">lyrics=</span><span class="method-args">(lyrics)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000061-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000061-source">
<pre>
    <span class="ruby-comment cmt"># File lib/lyric_parser.rb, line 12</span>
12:     <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">lyrics=</span>(<span class="ruby-identifier">lyrics</span>)
13:       <span class="ruby-ivar">@lyrics</span> = <span class="ruby-identifier">lyrics</span>
14:       <span class="ruby-ivar">@parsed_lyrics</span> = <span class="ruby-keyword kw">nil</span>
15:     <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000062" class="method-detail">
        <a name="M000062"></a>

        <div class="method-heading">
          <a href="#M000062" class="method-signature">
          <span class="method-name">parse</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000062-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000062-source">
<pre>
    <span class="ruby-comment cmt"># File lib/lyric_parser.rb, line 17</span>
17:     <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">parse</span>
18:       <span class="ruby-ivar">@parsed_lyrics</span> <span class="ruby-operator">||=</span> <span class="ruby-identifier">parse!</span>
19:       <span class="ruby-ivar">@parsed_lyrics</span>
20:     <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000063" class="method-detail">
        <a name="M000063"></a>

        <div class="method-heading">
          <a href="#M000063" class="method-signature">
          <span class="method-name">parse!</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000063-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000063-source">
<pre>
    <span class="ruby-comment cmt"># File lib/lyric_parser.rb, line 22</span>
22:     <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">parse!</span>
23:       <span class="ruby-identifier">parsed</span> = {}
24:       
25:       <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>] = <span class="ruby-ivar">@lyrics</span>.<span class="ruby-identifier">strip</span>.<span class="ruby-identifier">gsub</span>(<span class="ruby-value str">&quot;\r\n&quot;</span>, <span class="ruby-value str">&quot;\n&quot;</span>).<span class="ruby-identifier">split</span>(<span class="ruby-regexp re">/\n[ \t]*\n/</span>)
26:       <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>].<span class="ruby-identifier">collect!</span> { <span class="ruby-operator">|</span><span class="ruby-identifier">s</span><span class="ruby-operator">|</span> <span class="ruby-identifier">s</span>.<span class="ruby-identifier">strip</span> }
27:       <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>].<span class="ruby-identifier">reject!</span> { <span class="ruby-operator">|</span><span class="ruby-identifier">s</span><span class="ruby-operator">|</span> <span class="ruby-identifier">s</span>.<span class="ruby-identifier">empty?</span> }
28:       
29:       <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>].<span class="ruby-identifier">each_with_index</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">s</span>,<span class="ruby-identifier">idx</span><span class="ruby-operator">|</span>
30:         [<span class="ruby-identifier">:chorus</span>, <span class="ruby-identifier">:bridge</span>].<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">sub</span><span class="ruby-operator">|</span>
31:           <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">s</span> <span class="ruby-operator">=~</span> <span class="ruby-constant">Regexp</span>.<span class="ruby-identifier">new</span>(<span class="ruby-node">&quot;^\\[#{sub}\\]&quot;</span>) <span class="ruby-keyword kw">and</span> <span class="ruby-operator">!</span><span class="ruby-identifier">parsed</span>.<span class="ruby-identifier">has_key?</span>(<span class="ruby-identifier">sub</span>)
32:             <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">sub</span>] = <span class="ruby-identifier">s</span>.<span class="ruby-identifier">split</span>(<span class="ruby-value str">&quot;\n&quot;</span>)[<span class="ruby-value">1</span><span class="ruby-operator">..</span><span class="ruby-value">-1</span>].<span class="ruby-identifier">join</span>(<span class="ruby-value str">&quot;\n&quot;</span>)
33:             <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>][<span class="ruby-identifier">idx</span>] = <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">sub</span>]
34:           <span class="ruby-keyword kw">end</span>
35:         
36:           <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>][<span class="ruby-identifier">idx</span>].<span class="ruby-identifier">gsub!</span>(<span class="ruby-node">&quot;[#{sub}]&quot;</span>, <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">sub</span>]) <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">sub</span>]
37:         <span class="ruby-keyword kw">end</span>
38:         
39:         <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">s</span> <span class="ruby-operator">=~</span> <span class="ruby-regexp re">/^\[([2-9])x\]/</span>
40:           <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>][<span class="ruby-identifier">idx</span>] = (<span class="ruby-value">1</span><span class="ruby-operator">..</span>(<span class="ruby-identifier">$1</span>.<span class="ruby-identifier">to_i</span>)).<span class="ruby-identifier">collect</span> { <span class="ruby-identifier">s</span>.<span class="ruby-identifier">split</span>(<span class="ruby-value str">&quot;\n&quot;</span>)[<span class="ruby-value">1</span><span class="ruby-operator">..</span><span class="ruby-value">-1</span>].<span class="ruby-identifier">join</span>(<span class="ruby-value str">&quot;\n&quot;</span>) }
41:         <span class="ruby-keyword kw">end</span>
42:       <span class="ruby-keyword kw">end</span>
43:       
44:       <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>].<span class="ruby-identifier">flatten!</span>
45:       
46:       <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>].<span class="ruby-identifier">each_with_index</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">s</span>,<span class="ruby-identifier">idx</span><span class="ruby-operator">|</span>
47:         <span class="ruby-identifier">slide</span> = <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>][<span class="ruby-identifier">idx</span>].<span class="ruby-identifier">split</span>(<span class="ruby-value str">&quot;\n&quot;</span>)
48:         <span class="ruby-identifier">slide</span>.<span class="ruby-identifier">each_with_index</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">line</span>,<span class="ruby-identifier">i</span><span class="ruby-operator">|</span>
49:           <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">line</span>.<span class="ruby-identifier">strip</span> <span class="ruby-operator">=~</span> <span class="ruby-regexp re">/\[([2-9])x\]$/</span>
50:             <span class="ruby-identifier">num</span> = <span class="ruby-identifier">$1</span>.<span class="ruby-identifier">to_i</span>
51:             <span class="ruby-identifier">line</span> = <span class="ruby-identifier">line</span>.<span class="ruby-identifier">gsub</span>(<span class="ruby-node">&quot;[#{num}x]&quot;</span>, <span class="ruby-value str">&quot;&quot;</span>).<span class="ruby-identifier">strip</span>
52:             <span class="ruby-identifier">slide</span>[<span class="ruby-identifier">i</span>] = (<span class="ruby-value">1</span><span class="ruby-operator">..</span><span class="ruby-identifier">num</span>).<span class="ruby-identifier">collect</span> { <span class="ruby-identifier">line</span> }
53:           <span class="ruby-keyword kw">end</span>
54:         <span class="ruby-keyword kw">end</span>
55:         <span class="ruby-identifier">parsed</span>[<span class="ruby-identifier">:slides</span>][<span class="ruby-identifier">idx</span>] = <span class="ruby-identifier">slide</span>.<span class="ruby-identifier">flatten</span>.<span class="ruby-identifier">join</span>(<span class="ruby-value str">&quot;\n&quot;</span>)
56:       <span class="ruby-keyword kw">end</span>
57:       
58:       <span class="ruby-identifier">parsed</span>
59:     <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000064" class="method-detail">
        <a name="M000064"></a>

        <div class="method-heading">
          <a href="#M000064" class="method-signature">
          <span class="method-name">to_slides</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000064-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000064-source">
<pre>
    <span class="ruby-comment cmt"># File lib/lyric_parser.rb, line 61</span>
61:     <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">to_slides</span>
62:       <span class="ruby-identifier">parse</span>[<span class="ruby-identifier">:slides</span>]
63:     <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>


    </div>


  </div>


<div id="validator-badges">
  <p><small><a href="http://validator.w3.org/check/referer">[Validate]</a></small></p>
</div>

</body>
</html>